Bug 1310336 - EPSON printer drivers usb backend SELinux denial
EPSON printer drivers usb backend SELinux denial
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: selinux-policy (Show other bugs)
23
Unspecified Unspecified
high Severity high
: ---
: ---
Assigned To: Lukas Vrabec
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-02-20 09:41 EST by Aleksandar Kostadinov
Modified: 2016-12-20 13:53 EST (History)
5 users (show)

See Also:
Fixed In Version: selinux-policy-3.13.1-158.12.fc23
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-20 13:53:30 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
new denial report (1.78 KB, text/plain)
2016-05-02 12:13 EDT, Aleksandar Kostadinov
no flags Details

  None (edit)
Description Aleksandar Kostadinov 2016-02-20 09:41:59 EST
Pasting setroubleshooter output below. In short, after installing v1.6.4 "wp-4525" [1] driver and restarting cups, there is a file created /var/run/ecblp0. The epson backend it seems uses that to operate the printer.

I thought we can change policy so that the file can be opened in cups context.

Or should that be fixed somehow in the driver RPM? I doubt EPSON will fix it though as their RPM build is targeting all sorts of distros and requires `lsb` package. 

To workaround the issue I did manually in console:

> chcon system_u:object_r:cupsd_var_run_t:s0 /var/run/ecblp0


[1] http://download.ebz.epson.net/dsc/search/01/search/searchModule (search for "wp-4525")

=================== PASTED DENIAL ===========================================

SELinux is preventing /usr/lib/cups/backend/ecblp from 'open' accesses on the fifo_file /run/ecblp0.

*****  Plugin catchall (100. confidence) suggests   **************************

If you believe that ecblp should be allowed open access on the ecblp0 fifo_file by default.
Then you should report this as a bug.
You can generate a local policy module to allow this access.
Do
allow this access for now by executing:
# grep ecblp /var/log/audit/audit.log | audit2allow -M mypol
# semodule -i mypol.pp

Additional Information:
Source Context                system_u:system_r:cupsd_t:s0-s0:c0.c1023
Target Context                unconfined_u:object_r:var_run_t:s0
Target Objects                /run/ecblp0 [ fifo_file ]
Source                        ecblp
Source Path                   /usr/lib/cups/backend/ecblp
Port                          <Unknown>
Host                          (removed)
Source RPM Packages           epson-printer-utility-1.0.0-1lsb3.2.x86_64
Target RPM Packages           
Policy RPM                    selinux-policy-3.13.1-158.6.fc23.noarch
Selinux Enabled               True
Policy Type                   targeted
Enforcing Mode                Enforcing
Host Name                     (removed)
Platform                      Linux (removed) 4.3.5-300.fc23.x86_64 #1 SMP Mon
                              Feb 1 03:18:41 UTC 2016 x86_64 x86_64
Alert Count                   1
First Seen                    2016-02-20 15:53:23 EET
Last Seen                     2016-02-20 15:53:23 EET
Local ID                      862c222e-0122-4e5e-b09f-b612f92837c2

Raw Audit Messages
type=AVC msg=audit(1455976403.965:1640): avc:  denied  { open } for  pid=27960 comm="ecblp" path="/run/ecblp0" dev="tmpfs" ino=207126 scontext=system_u:system_r:cupsd_t:s0-s0:c0.c1023 tcontext=unconfined_u:object_r:var_run_t:s0 tclass=fifo_file permissive=0


type=SYSCALL msg=audit(1455976403.965:1640): arch=x86_64 syscall=open success=no exit=EACCES a0=7ffe49ad63f0 a1=81 a2=0 a3=120 items=0 ppid=26032 pid=27960 auid=4294967295 uid=4 gid=7 euid=4 suid=4 fsuid=4 egid=7 sgid=7 fsgid=7 tty=(none) ses=4294967295 comm=ecblp exe=/usr/lib/cups/backend/ecblp subj=system_u:system_r:cupsd_t:s0-s0:c0.c1023 key=(null)

Hash: ecblp,cupsd_t,var_run_t,fifo_file,open
Comment 1 Lukas Vrabec 2016-03-16 17:29:10 EDT
commit 6f85286ad59733ea7e65d54f5eaf563960ae6f10
Author: Lukas Vrabec <lvrabec@redhat.com>
Date:   Wed Mar 16 22:00:02 2016 +0100

    Label /var/run/ecblp0 as cupsd_var_run_t due to this fifo_file is used by epson drivers. rhbz#1310336
Comment 2 Aleksandar Kostadinov 2016-03-17 03:43:31 EDT
I don't know your rule and I'm not sure epson drivers have support for multiple printers [1], but it appears to me that we want any /var/run/ecblp# labeled as `cupsd_var_run_t`. 

[1] don't have multiple printers to test with
Comment 3 Fedora Update System 2016-03-30 10:40:54 EDT
selinux-policy-3.13.1-158.12.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-1cdba6b1c7
Comment 4 Fedora Update System 2016-03-30 18:54:33 EDT
selinux-policy-3.13.1-158.12.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-1cdba6b1c7
Comment 5 Fedora Update System 2016-04-05 09:52:00 EDT
selinux-policy-3.13.1-158.12.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 6 Fedora Update System 2016-04-05 12:19:41 EDT
selinux-policy-3.13.1-158.12.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 7 Aleksandar Kostadinov 2016-05-02 12:13 EDT
Created attachment 1153001 [details]
new denial report

I just had a chance to try that again. I still get the newly attached denial. I have `selinux-policy-3.13.1-158.14.fc23.noarch`. This is after reboot of the OS.

I'm not sure why it is not working. Please note that the fifo is created by a systemctl service. It does not exist before `systemctl start ecbd`. Only then "/run/ecblp0" is created. Let me know if you need any other info.
Comment 8 Fedora End Of Life 2016-11-24 10:40:03 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 9 Fedora End Of Life 2016-12-20 13:53:30 EST
Fedora 23 changed to end-of-life (EOL) status on 2016-12-20. Fedora 23 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.